# Ipopt::IdentityMatrix Class Reference

Class for Matrices which are multiples of the identity matrix. More...

`#include <IpIdentityMatrix.hpp>`

Inheritance diagram for Ipopt::IdentityMatrix:
[legend]

List of all members.

## Public Member Functions
void | SetFactor (Number factor)
| Method for setting the factor for the identity matrix.
Number | GetFactor () const
| Method for getting the factor for the identity matrix.
Index | Dim () const
| Method for obtaining the dimention of the matrix.
Constructors / Destructors
| IdentityMatrix (const SymMatrixSpace *owner_space)
| Constructor, initializing with dimensions of the matrix (true identity matrix).
| ~IdentityMatrix ()
| Destructor.
## Protected Member Functions
Methods overloaded from matrix
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply.
virtual void | AddMSinvZImpl (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z).
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan).
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix.
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| IdentityMatrix ()
| Default Constructor.
| IdentityMatrix (const IdentityMatrix &)
| Copy Constructor.
void | operator= (const IdentityMatrix &)
| Overloaded Equals Operator.
## Private Attributes
Number | factor_
| Scaling factor for this identity matrix.

## Detailed Description

Class for Matrices which are multiples of the identity matrix.

Definition at line 21 of file IpIdentityMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::IdentityMatrix::IdentityMatrix | ( | const SymMatrixSpace * | owner_space | ) |

Constructor, initializing with dimensions of the matrix (true identity matrix).

Ipopt::IdentityMatrix::~IdentityMatrix | ( |  | ) |

Destructor.

Ipopt::IdentityMatrix::IdentityMatrix | ( |  | ) | `[private]`

Default Constructor.

Ipopt::IdentityMatrix::IdentityMatrix | ( | const IdentityMatrix & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

void Ipopt::IdentityMatrix::SetFactor | ( | Number | factor | ) | `[inline]`

Method for setting the factor for the identity matrix.

Definition at line 38 of file IpIdentityMatrix.hpp.

Number Ipopt::IdentityMatrix::GetFactor | ( |  | ) | const`[inline]`

Method for getting the factor for the identity matrix.

Definition at line 44 of file IpIdentityMatrix.hpp.

Index Ipopt::IdentityMatrix::Dim | ( |  | ) | const

Method for obtaining the dimention of the matrix.

Reimplemented from Ipopt::SymMatrix.

virtual void Ipopt::IdentityMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y |
| ) |  |  | const`[protected, virtual]`

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual void Ipopt::IdentityMatrix::AddMSinvZImpl | ( | Number | alpha,
|  | const Vector & | S,
|  | const Vector & | Z,
|  | Vector & | X |
| ) |  |  | const`[protected, virtual]`

X = X + alpha*(Matrix S^{-1} Z).

Prototype for this specialize method is provided, but for efficient implementation it should be overloaded for the expansion matrix.

Reimplemented from Ipopt::Matrix.

virtual bool Ipopt::IdentityMatrix::HasValidNumbersImpl | ( |  | ) | const`[protected, virtual]`

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::IdentityMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init |
| ) |  |  | const`[protected, virtual]`

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::IdentityMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix |
| ) |  |  | const`[protected, virtual]`

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::IdentityMatrix::operator= | ( | const IdentityMatrix & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented from Ipopt::Matrix.

## Member Data Documentation

Number Ipopt::IdentityMatrix::factor_`[private]`

Scaling factor for this identity matrix.

Definition at line 95 of file IpIdentityMatrix.hpp.

The documentation for this class was generated from the following file:

- src/LinAlg/IpIdentityMatrix.hpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines